//Inputs/Outputs
int X_pin = 6;     
int Y_pin = 5;     
int Pot = A0;

int point_delay = 1000;         //Delay between loops in us      
#define how_many_vertices  108   //Put here the amount of vertices that you ahve            


// x coords for drawing the tree (in rough clockwise order, from bottom)
unsigned char x_happy_holiday[how_many_vertices] = {
  40,35,35,30,30,25,25,30,30,35,35,40,40,
  45,45,50,50,55,55,60,60,45,
  65,65,70,70,80,80,65,
  85,85,90,90,100,100,85,100,
  110,110,105,110,112,115,120,115,115,110,
  125,130,130,135,135,140,135,132,130,125,
  120,120,115,115,110,110,105,105,120,
  90,100,100,90,85,85,90,
  75,70,70,65,70,72,75,80,75,75,
  60,45,45,50,50,60,60,
  40,25,25,40,40,
  20,15,15,10,10,5,5,10,10,15,15,20,20
  };

// y coords
unsigned char y_happy_holiday[how_many_vertices] = { 
  35,35,45,45,35,35,60,60,50,50,60,60,35,
  60,35,35,45,45,35,35,60,60,
  60,35,35,45,45,60,60,
  60,35,35,45,45,60,60,60,
  35,45,60,60,50,60,60,45,35,35,
  30,15,5,5,15,30,30,20,30,30,
  30,5,5,15,15,5,5,30,30,
  30,20,15,5,5,30,30,
  5,5,15,30,30,20,30,30,15,5,
  5,5,30,30,10,10,5,
  5,5,30,30,5,
  5,5,15,15,5,5,30,30,20,20,30,30,5 
  };






  

void setup()
{
  pinMode(X_pin,OUTPUT);      //Define the pin as output
  pinMode(Y_pin,OUTPUT);      //Define the pin as output
  pinMode(Pot,INPUT);         //Define the pin as input for the potentiometer

  //Now we adjust PWM frequency using Prescale_factor
  TCCR0A =  (TCCR0A & B10100011 + TCCR0A | B10100011);  //(1<<COM0A1 | 0<<COM0A0 | 1<<COM0B1 | 0<<COM0B0 | 1<<WGM01 | 1<<WGM00);
  TCCR0B =  (TCCR0B & B00000001 + TCCR0B | B00000001);  //(0<<FOC0A | 0<<FOC0B | 0<<WGM02 | 0<<CS02 | 0<<CS01 | 1<<CS00);
  TIMSK0 =  (TIMSK0 & B11111000);                       //(0<<OCIE0B | 0<<OCIE0A  | 0<<TOIE0);

}

void loop() {
  unsigned char loopcount;
  {
    point_delay = map(analogRead(Pot),0,1024,10,2000);                //Read analog value adn map it to a range between 10 and 2000us
    for(loopcount = 0; loopcount < how_many_vertices; loopcount++)
    {
      analogWrite(X_pin,x_happy_holiday[loopcount]);                           //In this "for" we change the analog PWM width according to X axis and Y axis
      analogWrite(Y_pin,y_happy_holiday[loopcount]);
      delayMicroseconds(point_delay);                                 //Add the delay
    }
  }
}
